<script>
  // Import
  import { scaleLinear, scaleBand } from 'd3-scale';
  import { select } from 'd3-selection';
  import { axisBottom, axisLeft } from 'd3-axis';

  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Configure scales
  var yScale = scaleLinear([0,3],[innerHeight,0]);
  var xScale = scaleBand().range([0,innerWidth]).domain(["Netflix","Amazon Prime Video","Disney+","Hulu","Apple TV","Rakuten"])

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  // Axis functions
  function xAxis(element) {
    select(element).call(axisBottom(xScale))
  }
  function yAxis(element) {
    select(element).call(axisLeft(yScale))
  }
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    {#each data as index}
      <rect x="{xScale(index.service)}" y="{yScale(index.viewers)}" width="70" height="{innerHeight-yScale(index.viewers)}"/>
      console.log({index});
    {/each}
    <g use:xAxis transform='translate(-10, 260)'></g>
    <g use:yAxis transform='translate(-10, 0)'></g>
  </g>
  <text 
    transform='translate(15,220),rotate(-90)'
    style="fill:currentcolor; 
         font-size:14px;">
    Number of viewers (mio.)
  </text>
</svg>

<style>
  rect {
    fill: green;
  }
</style>